<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

	use Doctrine\ORM\EntityManager;
	use Zeedhi\Framework\DataSource\Manager\SQL\ManagerImpl;
	use Teknisa\Libs\Util\Environment;
	use Zeedhi\Framework\DataSource\FilterCriteria;
	use Zeedhi\Framework\DataSource\DataSet;
	
	class ped02600ParametrosPedidosService{
		protected $entityManager;
		protected $environment;
	    protected $dataSourceManager;
		protected $ped02600ParametrosPedidosFactory;
    
		public function __construct(EntityManager $entityManager, Environment $environment, ManagerImpl $dataSourceManager, $ped02600ParametrosPedidosFactory){
			$this->entityManager        	= $entityManager;
			$this->environment				= $environment;
	        $this->dataSourceManager		= $dataSourceManager;
			$this->ped02600ParametrosPedidosFactory = $ped02600ParametrosPedidosFactory;
            
		}
	
		public function saveRowParamPed($rows){
			

			try{
	        	$connection = $this->entityManager->getConnection();
    	        $connection->beginTransaction();
    	            
    	      	$rows = $this->adicionaCampos($rows);
    	      	
    	      	
	            
	            $erro = array();
	            
	        	$existeNaParGer = $this->ped02600ParametrosPedidosFactory->selectParGer($rows['NRORG']);
	        	if(!(empty($existeNaParGer))){
	         		$this->ped02600ParametrosPedidosFactory->salvaParGer($rows['NRORG'], $rows['IDUTCTREMPEN']);
               	} else {
	            	array_push($erro,'Não existe registro na tabela de Parametros Gerais.');
	            }
	            
	            
	            if(isset($rows['CDGRUPOPATPR'])){
	            	$existaATPR = $this->ped02600ParametrosPedidosFactory->selectAutGrupATPR($rows['NRORG'], $rows['CDFILIAL']);
	            	if($existaATPR){
	            		if($existaATPR[0]['CDGRUPOPER'] !== $rows['CDGRUPOPATPR']){
	            			$this->ped02600ParametrosPedidosFactory->uptdateAutoGrupATPR($rows['NRORG'], $rows['CDGRUPOPATPR'], $existaATPR[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
	            		}	
	            	} else {
	            		$NRAUTGRUPOP = $this->ped02600ParametrosPedidosFactory->selectMaxNrAutGrupATPR($rows['NRORG']);
	            		if($NRAUTGRUPOP[0]['NRAUTGRUPOP'] === NULL){
			            	$NRAUTGRUPOP[0]['NRAUTGRUPOP'] = '000';
			            	$this->ped02600ParametrosPedidosFactory->insertAutGrupATPR($rows['NRORG'], $rows['CDGRUPOPATPR'], $NRAUTGRUPOP[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
			            } else {
			            	$NRAUTGRUPOP[0]['NRAUTGRUPOP'] = str_pad(++$NRAUTGRUPOP[0]['NRAUTGRUPOP'], 3, "0", STR_PAD_LEFT);
			            	$this->ped02600ParametrosPedidosFactory->insertAutGrupATPR($rows['NRORG'], $rows['CDGRUPOPATPR'], $NRAUTGRUPOP[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
			            }
	            	}
	            }
	            
	            if(isset($rows['CDGRUPOPTPED'])){
	            	$existaTPED = $this->ped02600ParametrosPedidosFactory->selectAutGrupTPED($rows['NRORG'], $rows['CDFILIAL']);
	            	if($existaTPED){
	            		if($existaTPED[0]['CDGRUPOPER'] !== $rows['CDGRUPOPTPED']){
	            			$this->ped02600ParametrosPedidosFactory->uptdateAutoGrupTPED($rows['NRORG'], $rows['CDGRUPOPTPED'], $existaTPED[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
	            		}	
	            	} else {
	            		$NRAUTGRUPOP = $this->ped02600ParametrosPedidosFactory->selectMaxNrAutGrupTPED($rows['NRORG']);
	            		if($NRAUTGRUPOP[0]['NRAUTGRUPOP'] === NULL){
			            	$NRAUTGRUPOP[0]['NRAUTGRUPOP'] = '000';
			            	$this->ped02600ParametrosPedidosFactory->insertAutGrupTPED($rows['NRORG'], $rows['CDGRUPOPTPED'], $NRAUTGRUPOP[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
			            } else {
			            	$NRAUTGRUPOP[0]['NRAUTGRUPOP'] = str_pad(++$NRAUTGRUPOP[0]['NRAUTGRUPOP'], 3, "0", STR_PAD_LEFT);
			            	$this->ped02600ParametrosPedidosFactory->insertAutGrupTPED($rows['NRORG'], $rows['CDGRUPOPTPED'], $NRAUTGRUPOP[0]['NRAUTGRUPOP'], $rows['CDFILIAL']);
			            }
	            	}
	            }
	            
	            
	            $connection->commit();
	            
	           	return $erro;
	        }catch (\Exception $e) {
		        $this->entityManager->rollback();
		        throw $e;
		    }
			
		}
		
	    public function adicionaCampos($row) {

	        $nrorg = $this->environment->getNrorgTrab();
			$operador = $this->environment->getCdOperador();
			$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
			$row['NRORG'] = $nrorg;
			$row['DTINCLUSAO'] = $currentTime;
			$row['DTULTATU'] = $currentTime;
			$row['CDOPERINCLUSAO'] = $operador;
			$row['CDOPERULTATU'] = $operador;
			$row['IDATIVO'] = 'S';
			$row['NRORGINCLUSAO'] = $nrorg;
			$row['NRORGULTATU'] = $nrorg;
			$row['CDGROPERDESC'] = null;
			$row['IDTPCADCLIPE'] = '1';
			$row['CDGRUPPROD'] = null;
			$row['CDTIPORETI'] = null;
			$row['IDLIBRESECLI'] = 'N';
			$row['IDPERALTTPRE'] = 'S';
			$row['IDUTLIVPRECO'] = 'N';
			$row['NMMAQUI1DESTAVI'] = null;
			$row['NMMAQUI2DESTAVI'] = null;
			$row['DSMESNIMPPED'] = null;
			return $row;

    	}
	}

?>